window.Gleam.initSearch([{"doc":"defer_g","title":"defer_g","content":"# defer\n\nA simple library for adding defer functionality to gleam.\n\n[![Package Version](https://img.shields.io/hexpm/v/defer)](https://hex.pm/packages/defer)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/defer/)\n\n## Installation\n```sh\ngleam add defer\n```\n\n## Usage\n\ndefer is easy to use! (ha, ha get it?)\n```gleam\nimport defer\n\npub fn main() {\n  use &lt;- defer(fn() { io.println(&quot;1&quot;) })\n  use &lt;- defer(fn() { io.println(&quot;2&quot;) })\n  use &lt;- defer(fn() { io.println(&quot;3&quot;) })\n  io.println(&quot;4&quot;)\n}\n```\n```sh\n4\n3\n2\n1\n```\n\nNote that the defers execute in reverse! If you don&#39;t care about the order of your defers then\nthis is fine. However, If you would like the defers to execute in order then use `start_defer`\ninstead.\n```gleam\nimport defer\n\npub fn main() {\n  use ctx &lt;- start_defer(fn() { io.println(&quot;1&quot;) })\n  use ctx &lt;- add_defer(ctx, fn() { io.println(&quot;2&quot;) })\n  use ctx &lt;- add_defer(ctx, fn() { io.println(&quot;3&quot;) })\n  #(ctx, io.println(&quot;4&quot;))\n}\n```\n```sh\n4\n1\n2\n3\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/defer&gt;.\n\n## Development\n\nThis library is still a work in progress so feel free to suggest ways to make the api more\nergonomic and features that should be added.\n\n```sh\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"defer","title":"DeferContext","content":"pub opaque type DeferContext\n\n\nSynonyms:\ndefer.DeferContext\ndefer DeferContext","url":"defer.html#DeferContext"},{"doc":"defer","title":"add_defer","content":"pub fn add_defer(\n  context: DeferContext,\n  defer_func: fn() -&gt; Nil,\n  first: fn(DeferContext) -&gt; #(DeferContext, a),\n) -&gt; #(DeferContext, a)\n\nSynonyms:\ndefer.add_defer\ndefer add_defer","url":"defer.html#add_defer"},{"doc":"defer","title":"defer","content":"pub fn defer(\n  last defer_func: fn() -&gt; a,\n  first rest: fn() -&gt; b,\n) -&gt; b\n\nSynonyms:\ndefer.defer\ndefer defer","url":"defer.html#defer"},{"doc":"defer","title":"start_defer","content":"pub fn start_defer(\n  defer_func: fn() -&gt; Nil,\n  rest: fn(DeferContext) -&gt; #(DeferContext, a),\n) -&gt; a\n\nSynonyms:\ndefer.start_defer\ndefer start_defer","url":"defer.html#start_defer"},{"doc":"defer","title":"defer","content":"","url":"defer.html"}]);